﻿/**Begin D:\PDM_UPGRADE\PDM1\PBS_table.sql **/
 EXEC p_AlterColumn 'T_PBS_FLOWDEFROLE', 'FROLENAME', 'NVARCHAR(60)', 'NOT NULL', '0100', ''' ''';

IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_PBS_FLOWRUROLE' AND KSQL_COL_NAME ='FISCROSSROLE') 
 ALTER TABLE T_PBS_FLOWRUROLE ADD (FISCROSSROLE CHAR(1) DEFAULT '0' NOT NULL );
IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_PBS_FLOWRUROLE' AND KSQL_COL_NAME ='FCROSSROLESETID') 
 ALTER TABLE T_PBS_FLOWRUROLE ADD (FCROSSROLESETID BIGINT DEFAULT 0 NOT NULL );
IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_PBS_FLOWRUTASK' AND KSQL_COL_NAME ='FISCROSSEVALUATE') 
 ALTER TABLE T_PBS_FLOWRUTASK ADD (FISCROSSEVALUATE CHAR(1) DEFAULT '0' NOT NULL );
IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_PBS_FLOWRUTASK' AND KSQL_COL_NAME ='FBATCHNO') 
 ALTER TABLE T_PBS_FLOWRUTASK ADD (FBATCHNO VARCHAR(60) DEFAULT ' ' NOT NULL );
IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_PBS_FLOWRUTASK' AND KSQL_COL_NAME ='FMSGSTATUS') 
 ALTER TABLE T_PBS_FLOWRUTASK ADD (FMSGSTATUS VARCHAR(2) DEFAULT ' ' NOT NULL );
IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_PBS_INDROLESET') 
 CREATE TABLE T_PBS_INDROLESET (
FID BIGINT DEFAULT 0 NOT NULL,
FCREATORID BIGINT DEFAULT 0 NOT NULL,
FMODIFIERID BIGINT DEFAULT 0 NOT NULL,
FCREATETIME DATETIME,
FMODIFYTIME DATETIME,
FINDICATORID BIGINT DEFAULT 0 NOT NULL,
FCROSSROLESETNO VARCHAR(60) DEFAULT ' ' NOT NULL,
FEVAOBJID BIGINT DEFAULT 0 NOT NULL,
FAREAREGID BIGINT DEFAULT 0 NOT NULL
);


IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_PBS_CROSSROLESETENTRY') 
 CREATE TABLE T_PBS_CROSSROLESETENTRY (
FENTRYID BIGINT DEFAULT 0 NOT NULL,
FID BIGINT DEFAULT 0 NOT NULL,
FHANDLERID BIGINT DEFAULT 0 NOT NULL
);


IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_PBS_FLOWRUTASKINDENTRY') 
 CREATE TABLE T_PBS_FLOWRUTASKINDENTRY (
FENTRYID BIGINT DEFAULT 0 NOT NULL,
FID BIGINT DEFAULT 0 NOT NULL,
FINDICATORID BIGINT DEFAULT 0 NOT NULL,
FAREAREGID BIGINT DEFAULT 0 NOT NULL
);


IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_PBS_BATCHSTARTEVAOBJ') 
 CREATE TABLE T_PBS_BATCHSTARTEVAOBJ (
FID BIGINT DEFAULT 0 NOT NULL,
FCREATORID BIGINT DEFAULT 0 NOT NULL,
FMODIFIERID BIGINT DEFAULT 0 NOT NULL,
FCREATETIME DATETIME,
FMODIFYTIME DATETIME,
FBATCHNO VARCHAR(60) DEFAULT ' ' NOT NULL,
FTASKTYPE VARCHAR(2) DEFAULT ' ' NOT NULL,
FTASKSTATUS VARCHAR(2) DEFAULT ' ' NOT NULL
);


IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_PBS_BATCHSTARTENTRY') 
 CREATE TABLE T_PBS_BATCHSTARTENTRY (
FENTRYID BIGINT DEFAULT 0 NOT NULL,
FID BIGINT DEFAULT 0 NOT NULL,
FACTEVAOBJ BIGINT DEFAULT 0 NOT NULL,
FRUPROCPARAM VARCHAR(2000) DEFAULT ' ' NOT NULL,
FRUPROCID BIGINT DEFAULT 0 NOT NULL,
FTASKSTATUS VARCHAR(2) DEFAULT ' ' NOT NULL,
FTASKMSG VARCHAR(2000) DEFAULT ' ' NOT NULL,
FEXCUTECOUNT INT DEFAULT 0 NOT NULL
);


IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_PBS_CROSSROLESET') 
 CREATE TABLE T_PBS_CROSSROLESET (
FID BIGINT DEFAULT 0 NOT NULL,
FCREATORID BIGINT DEFAULT 0 NOT NULL,
FMODIFIERID BIGINT DEFAULT 0 NOT NULL,
FCREATETIME DATETIME,
FMODIFYTIME DATETIME,
FTURNOVERSORT INT DEFAULT 0 NOT NULL,
FROLEWEIGHT DECIMAL(19,6) DEFAULT 0 NOT NULL,
FDEFROLEID BIGINT DEFAULT 0 NOT NULL,
FSETNO VARCHAR(60) DEFAULT ' ' NOT NULL
);

IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_PBS_BATCHSTARTEVAOBJ' AND KSQL_COL_NAME ='FSTARTTIME') 
 ALTER TABLE T_PBS_BATCHSTARTEVAOBJ ADD (FSTARTTIME DATETIME );
IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_PBS_BATCHSTARTEVAOBJ' AND KSQL_COL_NAME ='FENDTIME') 
 ALTER TABLE T_PBS_BATCHSTARTEVAOBJ ADD (FENDTIME DATETIME );
 
IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_PBS_RUTASKCOHANDLER') 
 CREATE TABLE T_PBS_RUTASKCOHANDLER (
FENTRYID BIGINT DEFAULT 0 NOT NULL,
FID BIGINT DEFAULT 0 NOT NULL,
FCOHANDLERID BIGINT DEFAULT 0 NOT NULL,
FISCOHANDLED CHAR(1) DEFAULT '0' NOT NULL,
FSEQ INT DEFAULT 0 NOT NULL
);


IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_PBS_FLOWRUROLEENTRY') 
 CREATE TABLE T_PBS_FLOWRUROLEENTRY (
FENTRYID BIGINT DEFAULT 0 NOT NULL,
FID BIGINT DEFAULT 0 NOT NULL,
FRUROLEID BIGINT DEFAULT 0 NOT NULL,
FSEQ INT DEFAULT 0 NOT NULL
);
IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_PBS_CROSSROLESETENTRY' AND KSQL_COL_NAME ='FSEQ') 
 ALTER TABLE T_PBS_CROSSROLESETENTRY ADD (FSEQ INT DEFAULT 0 NOT NULL );
IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_PBS_FLOWRUTASKINDENTRY' AND KSQL_COL_NAME ='FSEQ') 
 ALTER TABLE T_PBS_FLOWRUTASKINDENTRY ADD (FSEQ INT DEFAULT 0 NOT NULL );
IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_PBS_BATCHSTARTENTRY' AND KSQL_COL_NAME ='FSEQ') 
 ALTER TABLE T_PBS_BATCHSTARTENTRY ADD (FSEQ INT DEFAULT 0 NOT NULL );

IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_PBS_FLOWRUNODE' AND KSQL_COL_NAME ='FISCROSSNODE') 
 ALTER TABLE T_PBS_FLOWRUNODE ADD (FISCROSSNODE CHAR(1) DEFAULT '0' NOT NULL );
 
IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_PBS_FLOWRUROLE' AND KSQL_COL_NAME ='FSETNO') 
ALTER TABLE T_PBS_FLOWRUROLE ADD (FSETNO VARCHAR(60) DEFAULT ' ' NOT NULL );

IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_PBS_FLOWRUROLE' AND KSQL_COL_NAME ='FISHANDLEREMPTY') 
 ALTER TABLE T_PBS_FLOWRUROLE ADD (FISHANDLEREMPTY CHAR(1) DEFAULT '0' NOT NULL );
 
 IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_PBS_INDROLESET' AND KSQL_COL_NAME ='FNODEDEFID') 
 ALTER TABLE T_PBS_INDROLESET ADD (FNODEDEFID BIGINT DEFAULT 0 NOT NULL );
IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_PBS_CROSSROLESET' AND KSQL_COL_NAME ='FNODEDEFID') 
 ALTER TABLE T_PBS_CROSSROLESET ADD (FNODEDEFID BIGINT DEFAULT 0 NOT NULL );
 
/**End D:\PDM_UPGRADE\PDM1\PBS_table.sql **/
